diff --git a/drivers/video/sunxi/lcd_fb/disp_lcd.c b/drivers/video/sunxi/lcd_fb/disp_lcd.c
index 9cf693c1d..edf50646a 100644
--- a/drivers/video/sunxi/lcd_fb/disp_lcd.c
+++ b/drivers/video/sunxi/lcd_fb/disp_lcd.c
@@ -768,40 +907,38 @@ void spi_dbi_config_init(struct disp_lcd_private_data *lcdp, struct sunxi_dbi_co
 		dbi_config->dbi_video_h = lcdp->panel_info.lines_per_transfer;
 		dbi_config->dbi_src_sequence = lcdp->panel_info.lcd_rgb_order;
 		dbi_config->dbi_te_en = 0;
-		dbi_config->dbi_vsync_handle = disp_lcd_vsync_handle;
-		dbi_config->dbi_clk_out_mode = lcdp->panel_info.lcd_dbi_clk_mode;
+		dbi_config->dbi_vsync_handle =
+			sunxi_lcd_fb_disp_lcd_vsync_handle;
+		dbi_config->dbi_clk_out_mode =
+			lcdp->panel_info.lcd_dbi_clk_mode;
 	}
 #endif
 }
 
-static s32 disp_lcd_spi_init(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_spi_init(struct sunxi_lcd_fb_device *lcd)
 {
 	int ret = -1;
 	struct spi_master *master;
+#if defined(SUPPORT_DBI_IF)
 	struct sunxi_dbi_config dbi_config;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+#endif
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
 	if (!lcd || !lcdp) {
-		lcd_fb_wrn("Null pointer!\n");
+		LCDFB_WRN("Null pointer!\n");
 		return -1;
 	}
 
-	master = spi_busnum_to_master(lcdp->panel_info.lcd_spi_bus_num);
-	if (!master) {
-		lcd_fb_wrn("fail to get master\n");
-		goto OUT;
-	}
-
-	lcd->spi_device = spi_alloc_device(master);
 	if (!lcd->spi_device) {
-		lcd_fb_wrn("fail to get spi device\n");
+		LCDFB_WRN("fail to get spi device\n");
 		goto OUT;
 	}
 	lcdp->spi_device = lcd->spi_device;
 
 	lcd->spi_device->bits_per_word = 8;
 	lcd->spi_device->max_speed_hz =
-	    lcdp->panel_info.lcd_data_speed * 1000 * 1000;
+		lcdp->panel_info.lcd_data_speed * 1000 * 1000;
 	lcd->spi_device->mode = SPI_MODE_0;
 
 #if defined(SUPPORT_DBI_IF)
@@ -828,23 +965,23 @@ static s32 disp_lcd_spi_init(struct lcd_fb_device *lcd)
 		dbi_config.dbi_video_h = lcdp->panel_info.lines_per_transfer;
 		dbi_config.dbi_src_sequence = lcdp->panel_info.lcd_rgb_order;
 		dbi_config.dbi_te_en = 0;
-		dbi_config.dbi_vsync_handle = disp_lcd_vsync_handle;
+		dbi_config.dbi_vsync_handle =
+			sunxi_lcd_fb_disp_lcd_vsync_handle;
 		dbi_config.dbi_clk_out_mode = lcdp->panel_info.lcd_dbi_clk_mode;
-	}
 
-	sunxi_dbi_set_config(lcd->spi_device, &dbi_config);
+		sunxi_dbi_set_config(lcd->spi_device, &dbi_config);
+	}
 #endif
 
 	ret = spi_setup(lcd->spi_device);
 	if (ret) {
-		lcd_fb_wrn("Faile to setup spi\n");
+		LCDFB_WRN("Faile to setup spi\n");
 		goto FREE;
 	}
 
-	lcd_fb_wrn("Init spi%d:bits_per_word:%d max_speed_hz:%d mode:%d\n",
-		   lcdp->panel_info.lcd_spi_bus_num,
-		   lcd->spi_device->bits_per_word,
-		   lcd->spi_device->max_speed_hz, lcd->spi_device->mode);
+	LCDFB_WRN("Init spi:bits_per_word:%d max_speed_hz:%d mode:%d\n",
+		  lcd->spi_device->bits_per_word, lcd->spi_device->max_speed_hz,
+		  lcd->spi_device->mode);
 
 	ret = 0;
 	goto OUT;
@@ -857,26 +994,34 @@ OUT:
 	return ret;
 }
 
-static s32 disp_lcd_enable(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_enable(struct sunxi_lcd_fb_device *lcd)
 {
 	unsigned long flags;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	int i;
 	unsigned bl;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
-	lcd_fb_inf("lcd %d\n", lcd->disp);
 
-	if (disp_lcd_is_enabled(lcd) == 1)
+	LCDFB_INF("lcd %d\n", lcd->disp);
+
+	if (sunxi_lcd_fb_disp_lcd_is_enabled(lcd) == 1)
 		return 0;
 
 	/* init fix power */
 	for (i = 0; i < LCD_POWER_NUM; i++) {
 		if (lcdp->lcd_cfg.lcd_fix_power_used[i] == 1)
-			lcd_fb_power_enable(lcdp->lcd_cfg.lcd_fix_power[i]);
+			sunxi_lcd_fb_power_enable(
+				lcdp->lcd_cfg.lcd_fix_power[i]);
 	}
 
 	spin_lock_irqsave(&lcd_data_lock, flags);
@@ -885,14 +1030,18 @@ static s32 disp_lcd_enable(struct lcd_fb_device *lcd)
 	spin_unlock_irqrestore(&lcd_data_lock, flags);
 
 	lcdp->panel_extend_info.lcd_gamma_en = lcdp->panel_info.lcd_gamma_en;
-	disp_lcd_gpio_init(lcd);
+	sunxi_lcd_fb_disp_lcd_gpio_init(lcd);
 
-	lcd_fb_pwm_config(lcdp->pwm_info.dev, lcdp->pwm_info.duty_ns,
-			    lcdp->pwm_info.period_ns);
-	lcd_fb_pwm_set_polarity(lcdp->pwm_info.dev, lcdp->pwm_info.polarity);
+	if (lcdp->panel_info.lcd_pwm_used) {
+		sunxi_lcd_fb_pwm_config(lcdp->pwm_info.dev,
+					lcdp->pwm_info.duty_ns,
+					lcdp->pwm_info.period_ns);
+		sunxi_lcd_fb_pwm_set_polarity(lcdp->pwm_info.dev,
+					      lcdp->pwm_info.polarity);
+	}
 
-	if (disp_lcd_spi_init(lcd)) {
-		lcd_fb_wrn("Init spi fail!\n");
+	if (sunxi_lcd_fb_disp_lcd_spi_init(lcd)) {
+		LCDFB_WRN("Init spi fail!\n");
 		return -1;
 	}
 
@@ -901,50 +1050,58 @@ static s32 disp_lcd_enable(struct lcd_fb_device *lcd)
 	if (lcdp->lcd_panel_fun.cfg_open_flow)
 		lcdp->lcd_panel_fun.cfg_open_flow(lcd->disp);
 	else
-		lcd_fb_wrn("lcd_panel_fun[%d].cfg_open_flow is NULL\n", lcd->disp);
+		LCDFB_WRN("lcd_panel_fun[%d].cfg_open_flow is NULL\n",
+			  lcd->disp);
 
 	for (i = 0; i < lcdp->open_flow.func_num; i++) {
 		if (lcdp->open_flow.func[i].func) {
 			lcdp->open_flow.func[i].func(lcd->disp);
-			lcd_fb_inf("open flow:step %d finish, to delay %d\n", i,
-			       lcdp->open_flow.func[i].delay);
+			LCDFB_INF("open flow:step %d finish, to delay %d\n", i,
+				  lcdp->open_flow.func[i].delay);
 			if (lcdp->open_flow.func[i].delay != 0)
-				disp_delay_ms(lcdp->open_flow.func[i].delay);
+				sunxi_lcd_fb_disp_delay_ms(
+					lcdp->open_flow.func[i].delay);
 		}
 	}
 
 	if (lcdp->panel_info.lcd_fps && !lcdp->panel_info.lcd_dbi_te) {
 		hrtimer_init(&lcdp->timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
-		lcdp->timer.function = disp_lcd_timer_handle;
-		hrtimer_start(
-		    &lcdp->timer,
-		    ktime_set(0, 1000000000 / lcdp->panel_info.lcd_fps),
-		    HRTIMER_MODE_REL);
+		lcdp->timer.function = sunxi_lcd_fb_disp_lcd_timer_handle;
+		hrtimer_start(&lcdp->timer,
+			      ktime_set(0,
+					1000000000 / lcdp->panel_info.lcd_fps),
+			      HRTIMER_MODE_REL);
 	}
 
 	spin_lock_irqsave(&lcd_data_lock, flags);
 	lcdp->enabled = 1;
 	lcdp->enabling = 0;
 	spin_unlock_irqrestore(&lcd_data_lock, flags);
-	bl = disp_lcd_get_bright(lcd);
-	disp_lcd_set_bright(lcd, bl);
+	bl = sunxi_lcd_fb_disp_lcd_get_bright(lcd);
+	sunxi_lcd_fb_disp_lcd_set_bright(lcd, bl);
 
 	return 0;
 }
 
-static s32 disp_lcd_disable(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_disable(struct sunxi_lcd_fb_device *lcd)
 {
 	unsigned long flags;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	int i;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
 		return -1;
 	}
 
-	lcd_fb_inf("lcd %d\n", lcd->disp);
-	if (disp_lcd_is_enabled(lcd) == 0)
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
+		return -1;
+	}
+
+	LCDFB_INF("lcd %d\n", lcd->disp);
+	if (sunxi_lcd_fb_disp_lcd_is_enabled(lcd) == 0)
 		return 0;
 
 	spin_lock_irqsave(&lcd_data_lock, flags);
@@ -959,23 +1116,26 @@ static s32 disp_lcd_disable(struct lcd_fb_device *lcd)
 	if (lcdp->lcd_panel_fun.cfg_close_flow)
 		lcdp->lcd_panel_fun.cfg_close_flow(lcd->disp);
 	else
-		lcd_fb_wrn("lcd_panel_fun[%d].cfg_close_flow is NULL\n", lcd->disp);
+		LCDFB_WRN("lcd_panel_fun[%d].cfg_close_flow is NULL\n",
+			  lcd->disp);
 
 	for (i = 0; i < lcdp->close_flow.func_num; i++) {
 		if (lcdp->close_flow.func[i].func) {
 			lcdp->close_flow.func[i].func(lcd->disp);
-			lcd_fb_inf("close flow:step %d finish, to delay %d\n", i,
-			       lcdp->close_flow.func[i].delay);
+			LCDFB_INF("close flow:step %d finish, to delay %d\n", i,
+				  lcdp->close_flow.func[i].delay);
 			if (lcdp->close_flow.func[i].delay != 0)
-				disp_delay_ms(lcdp->close_flow.func[i].delay);
+				sunxi_lcd_fb_disp_delay_ms(
+					lcdp->close_flow.func[i].delay);
 		}
 	}
 
-	disp_lcd_gpio_exit(lcd);
+	sunxi_lcd_fb_disp_lcd_gpio_exit(lcd);
 
 	for (i = LCD_POWER_NUM - 1; i >= 0; i--) {
 		if (lcdp->lcd_cfg.lcd_fix_power_used[i] == 1)
-			lcd_fb_power_disable(lcdp->lcd_cfg.lcd_fix_power[i]);
+			sunxi_lcd_fb_power_disable(
+				lcdp->lcd_cfg.lcd_fix_power[i]);
 	}
 
 	if (lcd->spi_device) {
@@ -989,12 +1149,18 @@ static s32 disp_lcd_disable(struct lcd_fb_device *lcd)
 	return 0;
 }
 
-s32 disp_lcd_is_enabled(struct lcd_fb_device *lcd)
+s32 sunxi_lcd_fb_disp_lcd_is_enabled(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
@@ -1002,31 +1168,43 @@ s32 disp_lcd_is_enabled(struct lcd_fb_device *lcd)
 }
 
 /**
- * disp_lcd_check_if_enabled - check lcd if be enabled status
+ * sunxi_lcd_fb_disp_lcd_check_if_enabled - check lcd if be enabled status
  *
  * this function only be used by bsp_disp_sync_with_hw to check
  * the device enabled status when driver init
  */
-s32 disp_lcd_check_if_enabled(struct lcd_fb_device *lcd)
+s32 sunxi_lcd_fb_disp_lcd_check_if_enabled(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	int ret = 1;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
 	return ret;
 }
 
-static s32 disp_lcd_set_open_func(struct lcd_fb_device *lcd, LCD_FUNC func,
-				  u32 delay)
+static s32 sunxi_lcd_fb_disp_lcd_set_open_func(struct sunxi_lcd_fb_device *lcd,
+					       LCD_FUNC func, u32 delay)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
@@ -1039,13 +1217,19 @@ static s32 disp_lcd_set_open_func(struct lcd_fb_device *lcd, LCD_FUNC func,
 	return 0;
 }
 
-static s32 disp_lcd_set_close_func(struct lcd_fb_device *lcd, LCD_FUNC func,
-				   u32 delay)
+static s32 sunxi_lcd_fb_disp_lcd_set_close_func(struct sunxi_lcd_fb_device *lcd,
+						LCD_FUNC func, u32 delay)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
@@ -1058,44 +1242,55 @@ static s32 disp_lcd_set_close_func(struct lcd_fb_device *lcd, LCD_FUNC func,
 	return 0;
 }
 
-static s32 disp_lcd_set_panel_funs(struct lcd_fb_device *lcd, char *name,
-				   struct disp_lcd_panel_fun *lcd_cfg)
+static s32 sunxi_lcd_fb_disp_lcd_set_panel_funs(
+	struct sunxi_lcd_fb_device *lcd, char *name,
+	struct sunxi_lcd_fb_disp_lcd_panel_fun *lcd_cfg)
 {
-	char primary_key[20], drv_name[32];
+	char drv_name[32];
 	s32 ret;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct device_node *panel_node;
+	struct disp_lcd_private_data *lcdp;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL)
+		return -1;
+
+	panel_node = lcd->panel_node;
+	lcdp = sunxi_lcd_fb_disp_lcd_get_priv(lcd);
+
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
 		return -1;
 	}
 
-	sprintf(primary_key, "lcd_fb%d", lcd->disp);
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
+		return -1;
+	}
 
-	ret =
-	    lcd_fb_script_get_item(primary_key, "lcd_driver_name",
-				     (int *)drv_name, 2);
-	lcd_fb_inf("lcd %d, driver_name %s,  panel_name %s\n", lcd->disp, drv_name,
-	       name);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_driver_name",
+					   (int *)drv_name, 2);
+	LCDFB_INF("lcd %d, driver_name %s,  panel_name %s\n", lcd->disp,
+		  drv_name, name);
 	if ((ret == 2) && !strcmp(drv_name, name)) {
-		memset(&lcdp->lcd_panel_fun,
-		       0,
-		       sizeof(lcdp->lcd_panel_fun));
+		memset(&lcdp->lcd_panel_fun, 0, sizeof(lcdp->lcd_panel_fun));
 		lcdp->lcd_panel_fun.cfg_panel_info = lcd_cfg->cfg_panel_info;
 		lcdp->lcd_panel_fun.cfg_open_flow = lcd_cfg->cfg_open_flow;
 		lcdp->lcd_panel_fun.cfg_close_flow = lcd_cfg->cfg_close_flow;
 		lcdp->lcd_panel_fun.lcd_user_defined_func =
-		    lcd_cfg->lcd_user_defined_func;
+			lcd_cfg->lcd_user_defined_func;
 		lcdp->lcd_panel_fun.set_bright = lcd_cfg->set_bright;
 		lcdp->lcd_panel_fun.blank = lcd_cfg->blank;
 		lcdp->lcd_panel_fun.set_var = lcd_cfg->set_var;
 		lcdp->lcd_panel_fun.set_addr_win = lcd_cfg->set_addr_win;
 		if (lcdp->lcd_panel_fun.cfg_panel_info) {
-			lcdp->lcd_panel_fun.cfg_panel_info(&lcdp->panel_extend_info);
+			lcdp->lcd_panel_fun.cfg_panel_info(
+				&lcdp->panel_extend_info);
 			memcpy(&lcdp->panel_extend_info_set,
-				&lcdp->panel_extend_info, sizeof(lcdp->panel_extend_info_set));
+			       &lcdp->panel_extend_info,
+			       sizeof(lcdp->panel_extend_info_set));
 		} else {
-			lcd_fb_wrn("lcd_panel_fun[%d].cfg_panel_info is NULL\n", lcd->disp);
+			LCDFB_WRN("lcd_panel_fun[%d].cfg_panel_info is NULL\n",
+				  lcd->disp);
 		}
 
 		return 0;
@@ -1104,142 +1299,179 @@ static s32 disp_lcd_set_panel_funs(struct lcd_fb_device *lcd, char *name,
 	return -1;
 }
 
-s32 disp_lcd_gpio_init(struct lcd_fb_device *lcd)
+s32 sunxi_lcd_fb_disp_lcd_gpio_init(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	int i = 0;
 	struct disp_gpio_info gpio_info[1];
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
 	/* io-pad */
 	for (i = 0; i < LCD_GPIO_REGU_NUM; i++) {
-		if (!((!strcmp(lcdp->lcd_cfg.lcd_gpio_power[i], ""))
-			|| (!strcmp(lcdp->lcd_cfg.lcd_gpio_power[i], "none"))))
-			lcd_fb_power_enable(lcdp->lcd_cfg.lcd_gpio_power[i]);
+		if (!((!strcmp(lcdp->lcd_cfg.lcd_gpio_power[i], "")) ||
+		      (!strcmp(lcdp->lcd_cfg.lcd_gpio_power[i], "none"))))
+			sunxi_lcd_fb_power_enable(
+				lcdp->lcd_cfg.lcd_gpio_power[i]);
 	}
 
 	for (i = 0; i < LCD_GPIO_NUM; i++) {
 		if (lcdp->lcd_cfg.lcd_gpio_used[i]) {
 			memcpy(gpio_info, &(lcdp->lcd_cfg.lcd_gpio[i]),
-				sizeof(struct disp_gpio_info));
-			lcd_fb_gpio_request(gpio_info);
+			       sizeof(struct disp_gpio_info));
+			sunxi_lcd_fb_gpio_request(gpio_info);
 		}
 	}
 
 	if (strlen(lcdp->lcd_cfg.lcd_spi_dc_pin.name)) {
 		memcpy(gpio_info, &(lcdp->lcd_cfg.lcd_spi_dc_pin),
-					sizeof(struct disp_gpio_info));
-		lcd_fb_gpio_request(gpio_info);
+		       sizeof(struct disp_gpio_info));
+		sunxi_lcd_fb_gpio_request(gpio_info);
 	}
 
 	return 0;
 }
 
-s32 disp_lcd_gpio_exit(struct lcd_fb_device *lcd)
+s32 sunxi_lcd_fb_disp_lcd_gpio_exit(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	int i = 0;
 	struct disp_gpio_info gpio_info[1];
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
 	for (i = 0; i < LCD_GPIO_NUM; i++) {
 		if (lcdp->lcd_cfg.lcd_gpio_used[i]) {
-
-			lcd_fb_gpio_release(&lcdp->lcd_cfg.lcd_gpio[i]);
+			sunxi_lcd_fb_gpio_release(&lcdp->lcd_cfg.lcd_gpio[i]);
 
 			memcpy(gpio_info, &(lcdp->lcd_cfg.lcd_gpio[i]),
-					sizeof(struct disp_gpio_info));
+			       sizeof(struct disp_gpio_info));
 		}
 	}
 
 	/* io-pad */
 	for (i = LCD_GPIO_REGU_NUM - 1; i >= 0; i--) {
-		if (!((!strcmp(lcdp->lcd_cfg.lcd_gpio_power[i], ""))
-			|| (!strcmp(lcdp->lcd_cfg.lcd_gpio_power[i], "none"))))
-			lcd_fb_power_disable(lcdp->lcd_cfg.lcd_gpio_power[i]);
+		if (!((!strcmp(lcdp->lcd_cfg.lcd_gpio_power[i], "")) ||
+		      (!strcmp(lcdp->lcd_cfg.lcd_gpio_power[i], "none"))))
+			sunxi_lcd_fb_power_disable(
+				lcdp->lcd_cfg.lcd_gpio_power[i]);
 	}
 
 	if (strlen(lcdp->lcd_cfg.lcd_spi_dc_pin.name))
-		lcd_fb_gpio_release(&lcdp->lcd_cfg.lcd_spi_dc_pin);
+		sunxi_lcd_fb_gpio_release(&lcdp->lcd_cfg.lcd_spi_dc_pin);
 
 	return 0;
-
 }
 
 /* direction: input(0), output(1) */
-s32 disp_lcd_gpio_set_direction(struct lcd_fb_device *lcd, u32 io_index,
-				u32 direction)
+s32 sunxi_lcd_fb_disp_lcd_gpio_set_direction(struct sunxi_lcd_fb_device *lcd,
+					     u32 io_index, u32 direction)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	char gpio_name[20];
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
 	sprintf(gpio_name, "lcd_gpio_%d", io_index);
-	return lcd_fb_gpio_set_direction(lcdp->lcd_cfg.gpio_hdl[io_index],
-					   direction, gpio_name);
+	return sunxi_lcd_fb_gpio_set_direction(lcdp->lcd_cfg.gpio_hdl[io_index],
+					       direction, gpio_name);
 }
 
-s32 disp_lcd_gpio_get_value(struct lcd_fb_device *lcd, u32 io_index)
+s32 sunxi_lcd_fb_disp_lcd_gpio_get_value(struct sunxi_lcd_fb_device *lcd,
+					 u32 io_index)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	char gpio_name[20];
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
 	sprintf(gpio_name, "lcd_gpio_%d", io_index);
-	return lcd_fb_gpio_get_value(lcdp->lcd_cfg.gpio_hdl[io_index],
-				       gpio_name);
+	return sunxi_lcd_fb_gpio_get_value(lcdp->lcd_cfg.gpio_hdl[io_index],
+					   gpio_name);
 }
 
-s32 disp_lcd_gpio_set_value(struct lcd_fb_device *lcd, u32 io_index, u32 data)
+s32 sunxi_lcd_fb_disp_lcd_gpio_set_value(struct sunxi_lcd_fb_device *lcd,
+					 u32 io_index, u32 data)
 {
 	int gpio;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	char gpio_name[20];
 
 	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+		LCDFB_WRN("NULL hdl!\n");
 		return DIS_FAIL;
 	}
 
 	if (io_index >= LCD_GPIO_NUM) {
-		lcd_fb_wrn("gpio num out of range\n");
+		LCDFB_WRN("gpio num out of range\n");
 		return DIS_FAIL;
 	}
 	sprintf(gpio_name, "lcd_gpio_%d", io_index);
 	gpio = lcdp->lcd_cfg.lcd_gpio[io_index].gpio;
 	if (!gpio_is_valid(gpio)) {
-		lcd_fb_wrn("of_get_named_gpio_flags for %s failed\n", gpio_name);
+		LCDFB_WRN("of_get_named_gpio_flags for %s failed\n", gpio_name);
 		return DIS_FAIL;
 	}
 
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(6, 6, 0))
+	gpio_set_value(gpio, data);
+#else
 	__gpio_set_value(gpio, data);
+#endif
 
 	return DIS_SUCCESS;
 }
 
-static s32 disp_lcd_get_dimensions(struct lcd_fb_device *lcd, u32 *width,
-				   u32 *height)
+static s32 sunxi_lcd_fb_disp_lcd_get_dimensions(struct sunxi_lcd_fb_device *lcd,
+						u32 *width, u32 *height)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
@@ -1252,20 +1484,21 @@ static s32 disp_lcd_get_dimensions(struct lcd_fb_device *lcd, u32 *width,
 	return 0;
 }
 
-
-static s32 disp_lcd_update_gamma_tbl_set(struct lcd_fb_device *lcd)
+static s32
+sunxi_lcd_fb_disp_lcd_update_gamma_tbl_set(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	int i;
-	unsigned int *gamma, *gamma_set;
-	unsigned int r, g, b;
+	u32 *gamma, *gamma_set;
+	u32 r, g, b;
 	s32 color_temperature;
 	u32 color_inverse;
 
 	color_temperature = lcdp->color_temperature;
 	color_inverse = lcdp->color_inverse;
 	memcpy(&lcdp->panel_extend_info_set, &lcdp->panel_extend_info,
-		sizeof(lcdp->panel_extend_info_set));
+	       sizeof(lcdp->panel_extend_info_set));
 	gamma = lcdp->panel_extend_info.lcd_gamma_tbl;
 	gamma_set = lcdp->panel_extend_info_set.lcd_gamma_tbl;
 	if (color_temperature > 0) {
@@ -1300,7 +1533,7 @@ static s32 disp_lcd_update_gamma_tbl_set(struct lcd_fb_device *lcd)
 	}
 	if (color_inverse == 1) {
 		for (i = 0; i < 256; i++)
-			gamma_set[i] = 0xffffffff -  gamma_set[i];
+			gamma_set[i] = 0xffffffff - gamma_set[i];
 	}
 	if (color_inverse != 0)
 		lcdp->panel_extend_info_set.lcd_gamma_en = 1;
@@ -1310,44 +1543,43 @@ static s32 disp_lcd_update_gamma_tbl_set(struct lcd_fb_device *lcd)
 	return 0;
 }
 
-
-static s32 disp_lcd_set_gamma_tbl(struct lcd_fb_device *lcd,
-			unsigned int *gamma_table, unsigned int size)
+static s32 sunxi_lcd_fb_disp_lcd_set_gamma_tbl(struct sunxi_lcd_fb_device *lcd,
+					       u32 *gamma_table, u32 size)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	unsigned long flags;
 
-	if ((lcd == NULL) || (lcdp == NULL)
-	    || (gamma_table == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if ((lcd == NULL) || (lcdp == NULL) || (gamma_table == NULL)) {
+		LCDFB_WRN("NULL hdl!\n");
 		return 0;
 	}
 
-	size = (size > LCD_GAMMA_TABLE_SIZE) ?
-	    LCD_GAMMA_TABLE_SIZE : size;
+	size = (size > LCD_GAMMA_TABLE_SIZE) ? LCD_GAMMA_TABLE_SIZE : size;
 	spin_lock_irqsave(&lcd_data_lock, flags);
 	memcpy(lcdp->panel_extend_info.lcd_gamma_tbl, gamma_table, size);
-	disp_lcd_update_gamma_tbl_set(lcd);
+	sunxi_lcd_fb_disp_lcd_update_gamma_tbl_set(lcd);
 	lcdp->panel_extend_dirty = 1;
 	spin_unlock_irqrestore(&lcd_data_lock, flags);
 
 	return 0;
 }
 
-static s32 disp_lcd_enable_gamma(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_enable_gamma(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	unsigned long flags;
 
 	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+		LCDFB_WRN("NULL hdl!\n");
 		return 0;
 	}
 
 	spin_lock_irqsave(&lcd_data_lock, flags);
 	if (lcdp->panel_extend_info.lcd_gamma_en == 0) {
 		lcdp->panel_extend_info.lcd_gamma_en = 1;
-		disp_lcd_update_gamma_tbl_set(lcd);
+		sunxi_lcd_fb_disp_lcd_update_gamma_tbl_set(lcd);
 		lcdp->panel_extend_dirty = 1;
 	}
 	spin_unlock_irqrestore(&lcd_data_lock, flags);
@@ -1355,13 +1587,14 @@ static s32 disp_lcd_enable_gamma(struct lcd_fb_device *lcd)
 	return 0;
 }
 
-static s32 disp_lcd_disable_gamma(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_disable_gamma(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	int ret = -1;
 
 	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+		LCDFB_WRN("NULL hdl!\n");
 		return 0;
 	}
 
@@ -1376,34 +1609,43 @@ static s32 disp_lcd_disable_gamma(struct lcd_fb_device *lcd)
 	return ret;
 }
 
-static s32 disp_lcd_set_color_temperature(struct lcd_fb_device *lcd,
-	s32 color_temperature)
+static s32
+sunxi_lcd_fb_disp_lcd_set_color_temperature(struct sunxi_lcd_fb_device *lcd,
+					    s32 color_temperature)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	unsigned long flags;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
 	spin_lock_irqsave(&lcd_data_lock, flags);
 	lcdp->color_temperature = color_temperature;
-	disp_lcd_update_gamma_tbl_set(lcd);
+	sunxi_lcd_fb_disp_lcd_update_gamma_tbl_set(lcd);
 	lcdp->panel_extend_dirty = 1;
 	spin_unlock_irqrestore(&lcd_data_lock, flags);
 
 	return 0;
 }
 
-static s32 disp_lcd_get_color_temperature(struct lcd_fb_device *lcd)
+static s32
+sunxi_lcd_fb_disp_lcd_get_color_temperature(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	unsigned long flags;
 	s32 color_temperature = 0;
 
 	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+		LCDFB_WRN("NULL hdl!\n");
 		return 0;
 	}
 
@@ -1414,33 +1656,39 @@ static s32 disp_lcd_get_color_temperature(struct lcd_fb_device *lcd)
 	return color_temperature;
 }
 
-static int disp_lcd_backlight_update_status(struct backlight_device *bd)
+static int
+sunxi_lcd_fb_disp_lcd_backlight_update_status(struct backlight_device *bd)
 {
-	struct lcd_fb_device *lcd = (struct lcd_fb_device *)bd->dev.driver_data;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct sunxi_lcd_fb_device *lcd =
+		(struct sunxi_lcd_fb_device *)bd->dev.driver_data;
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	lcd_fb_inf("updating sunxi_backlight, brightness=%d/%d\n",
-		      bd->props.brightness, bd->props.max_brightness);
+	LCDFB_INF("updating sunxi_backlight, brightness=%d/%d\n",
+		  bd->props.brightness, bd->props.max_brightness);
 
 	mutex_lock(&lcdp->backligt_lock);
 	if (bd->props.power != FB_BLANK_POWERDOWN) {
 		if (!lcdp->bl_enabled)
-			disp_lcd_backlight_enable(lcd);
-		disp_lcd_set_bright(lcd, bd->props.brightness);
+			sunxi_lcd_fb_disp_lcd_backlight_enable(lcd);
+		sunxi_lcd_fb_disp_lcd_set_bright(lcd, bd->props.brightness);
 	} else {
-		disp_lcd_set_bright(lcd, 0);
+		sunxi_lcd_fb_disp_lcd_set_bright(lcd, 0);
 		if (lcdp->bl_enabled)
-			disp_lcd_backlight_disable(lcd);
+			sunxi_lcd_fb_disp_lcd_backlight_disable(lcd);
 	}
 	mutex_unlock(&lcdp->backligt_lock);
 
 	return 0;
 }
 
-static int disp_lcd_backlight_get_brightness(struct backlight_device *bd)
+static int
+sunxi_lcd_fb_disp_lcd_backlight_get_brightness(struct backlight_device *bd)
 {
-	struct lcd_fb_device *lcd = (struct lcd_fb_device *)bd->dev.driver_data;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct sunxi_lcd_fb_device *lcd =
+		(struct sunxi_lcd_fb_device *)bd->dev.driver_data;
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	int ret = -1;
 
 	if (!lcd || !lcdp)
@@ -1455,18 +1703,20 @@ OUT:
 }
 
 static const struct backlight_ops sunxi_backlight_device_ops = {
-	.update_status = disp_lcd_backlight_update_status,
-	.get_brightness = disp_lcd_backlight_get_brightness,
+	.update_status = sunxi_lcd_fb_disp_lcd_backlight_update_status,
+	.get_brightness = sunxi_lcd_fb_disp_lcd_backlight_get_brightness,
 };
 
-static s32 disp_lcd_backlight_register(struct lcd_fb_device *lcd)
+static s32
+sunxi_lcd_fb_disp_lcd_backlight_register(struct sunxi_lcd_fb_device *lcd)
 {
 	struct backlight_properties props;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
-	char sunxi_bl_name[40] = {0};
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
+	char sunxi_bl_name[40] = { 0 };
 
 	if (!lcdp || !lcd->dev) {
-		lcd_fb_wrn("NULL pointer\n");
+		LCDFB_WRN("NULL pointer\n");
 		return -1;
 	}
 
@@ -1483,67 +1733,76 @@ static s32 disp_lcd_backlight_register(struct lcd_fb_device *lcd)
 	props.power = FB_BLANK_UNBLANK;
 	snprintf(sunxi_bl_name, 40, "lcd_fb%d", lcd->disp);
 
-	lcdp->p_bl_dev = backlight_device_register(
-	    sunxi_bl_name, lcd->dev, lcd, &sunxi_backlight_device_ops, &props);
+	lcdp->p_bl_dev =
+		backlight_device_register(sunxi_bl_name, lcd->dev, lcd,
+					  &sunxi_backlight_device_ops, &props);
 
 	if (!lcdp->p_bl_dev) {
-		lcd_fb_wrn("backligt register fail!\n");
+		LCDFB_WRN("backligt register fail!\n");
 		return -2;
 	}
 
 	return 0;
 }
 
-static void disp_lcd_backlight_unregister(struct lcd_fb_device *lcd)
+static void
+sunxi_lcd_fb_disp_lcd_backlight_unregister(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
 	if (lcdp->p_bl_dev) {
 		backlight_device_unregister(lcdp->p_bl_dev);
 		lcdp->p_bl_dev = NULL;
 	} else
-		lcd_fb_wrn("lcd%d:Can not find corresponding backlight device\n", lcd->disp);
+		LCDFB_WRN("lcd%d:Can not find corresponding backlight device\n",
+			  lcd->disp);
 }
 
-
-static s32 disp_lcd_init(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_init(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	struct disp_gpio_info gpio_info;
 	int i;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
 		return -1;
 	}
-	lcd_fb_inf("lcd %d\n", lcd->disp);
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
+		return -1;
+	}
+
+	LCDFB_INF("lcd %d\n", lcd->disp);
 	mutex_init(&lcdp->layer_mlock);
 	mutex_init(&lcdp->backligt_lock);
 	init_waitqueue_head(&lcdp->wait);
 
-	lcd_get_sys_config(lcd->disp, &lcdp->lcd_cfg);
-	if (disp_lcd_is_used(lcd)) {
-		lcd_parse_panel_para(lcd->disp, &lcdp->panel_info);
+	sunxi_lcd_fb_lcd_get_sys_config(lcd->disp, &lcdp->lcd_cfg);
+	if (sunxi_lcd_fb_disp_lcd_is_used(lcd)) {
+		sunxi_lcd_fb_lcd_parse_panel_para(lcd->disp, &lcdp->panel_info);
 	}
-	disp_lcd_bright_curve_init(lcd);
+	sunxi_lcd_fb_disp_lcd_bright_curve_init(lcd);
 
-	if (disp_lcd_is_used(lcd)) {
+	if (sunxi_lcd_fb_disp_lcd_is_used(lcd)) {
 		__u64 backlight_bright;
 		__u64 period_ns, duty_ns;
 
 		if (lcdp->panel_info.lcd_pwm_used) {
 			lcdp->pwm_info.channel = lcdp->panel_info.lcd_pwm_ch;
 			lcdp->pwm_info.polarity = lcdp->panel_info.lcd_pwm_pol;
-			lcdp->pwm_info.dev =
-			    lcd_fb_pwm_request(lcdp->panel_info.lcd_pwm_ch);
+			lcdp->pwm_info.dev = sunxi_lcd_fb_pwm_request(
+				lcdp->panel_info.lcd_pwm_ch);
 
 			if (lcdp->panel_info.lcd_pwm_freq != 0) {
-				period_ns =
-				    1000 * 1000 * 1000 /
-				    lcdp->panel_info.lcd_pwm_freq;
+				period_ns = 1000 * 1000 * 1000 /
+					    lcdp->panel_info.lcd_pwm_freq;
 			} else {
-				lcd_fb_wrn("lcd%d.lcd_pwm_freq is ZERO\n",
-				       lcd->disp);
+				LCDFB_WRN("lcd%d.lcd_pwm_freq is ZERO\n",
+					  lcd->disp);
 				/* default 1khz */
 				period_ns = 1000 * 1000 * 1000 / 1000;
 			}
